.*------------------------------------------------------------------------*
.* Yet Another GetKey for REXX                                            *
.*========================================================================*
.* Copyright (c) 2015 VicTor Smirnoff                   iamvic@rambler.ru *
.*                                                                        *
.* Permission is hereby granted, free  of charge, to any person obtaining *
.* a  copy  of  this  software   and   associated   documentation   files *
.* (the  "Software"),  to  deal  in  the  Software  without  restriction, *
.* including without limitation  the rights  to use, copy, modify, merge, *
.* publish, distribute, sublicense,  and/or  sell copies of the Software, *
.* and  to permit persons  to whom  the Software  is furnished  to do so, *
.* subject to the following conditions:                                   *
.*                                                                        *
.* The above  copyright  notice  and  this  permission  notice  shall  be *
.* included in all copies or substantial portions of the Software.        *
.*                                                                        *
.* THE SOFTWARE  IS PROVIDED  "AS IS",  WITHOUT  WARRANTY  OF  ANY  KIND, *
.* EXPRESS OR IMPLIED,  INCLUDING  BUT  NOT LIMITED  TO THE WARRANTIES OF *
.* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. *
.* IN NO EVENT SHALL  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE  FOR ANY *
.* CLAIM, DAMAGES OR OTHER LIABILITY,  WHETHER IN AN ACTION  OF CONTRACT, *
.* TORT  OR  OTHERWISE,  ARISING  FROM,  OUT  OF  OR  IN  CONNECTION WITH *
.* THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.             *
.*------------------------------------------------------------------------*
:h3 id='en_yagetkeyver'.yaGetKeyVer
:font facename='Courier' size=14x8 codepage=850.
:p.
:hp2.3.4. yaGetKeyVer.:ehp2.
:p.
Returns the library version and another information.
:p.
:hp2.Syntax:ehp2.
:lm margin=5.
:xmp.:color bc=palegray.
Ŀ
  :color fc=darkgray.>:color fc=default.yaGetKeyVer(:color fc=darkgray.:color fc=default.):color fc=darkgray.><:color fc=default.   
                   :color fc=darkgray.:color fc=default.stem:color fc=darkgray.:color fc=default.          

:color bc=default.:exmp.
:lm margin=1.
.br
:hp2.Parameters:ehp2.
:lm margin=5.
:dl compact break=none tsize=10.
:dt.:color fc=darkgreen.stem:color fc=default.
:dd.(optional) the string containing a correct stem name
(may be without the final dot).
:p.
If the parameter is specified, the function stores the additional
information about the library in the stem.
The function assigns appropriate values to stem elements named as&colon.
:table cols='22 60' rules=none frame=none.
:row.
:c.stem.:color fc=darkgreen.0ABOUT
:c.:color fc=default.the string containing additional information about the library,
:row.
:c.stem.:color fc=darkgreen.0
:c.:color fc=default.the number of library functions,
:row.
:c.stem.:color fc=darkgreen.1
:c.:color fc=default.the string containing the name of the first function,
:row.
:c.stem.:color fc=darkgreen.2:color fc=default. (and above)
:c.:color fc=default.the string containing the name of the second function
(and above to the number of library functions).
:etable.
:edl.
:lm margin=1.
.br
:hp2.Return Value:ehp2.
:lm margin=5.
:p.
The string containing the version information.
:lm margin=1.
:p.
.br
:hp2.Errors:ehp2.
:lm margin=5.
:p.
The value of the KBDERRNO special variable does not change.
:lm margin=1.
:p.
:p.
:font facename='default' size=0x0.
